function out = computeLogL(yt,T,R,Q,M,S,ni,a1,P1)

N = length(yt);
n = sum(ni);
eyen = eye(n);
yt(isnan(yt))=0;

% T = sparse(T);
% Q = sparse(Q);
% R = sparse(R);
% M = sparse(M);
% S = sparse(S);

% Preliminaries

a = a1;
P = P1;

logL = 0;

for t=1:N
    
    W = eyen(~(yt(:,t)==0),:);
    y = W*yt(:,t);
    H = W*S*W';
    Z = W*M;
    
    v = y - Z*a;
    
    F = Z*P*Z'+H;
    [invF,logDetF]=invA(F);
    K = T*P*Z'*invF;
    
    a = T*a+K*v;
    P = T*P*(T-K*Z)'+R*Q*R';
    
    logL = logL -.5*(logDetF + v'*invF*v);
    
end

out = logL;

