
nIter = 2000;         % maximum n. of iterations
tol = 1e-6;          % min likelihood changing tolerance

showPlot = false;

% EM initialization
C = [eye(d),zeros(d)];

Q0 = [squeeze(QKEM(i,:,:)),zeros(d);zeros(d,2*d)];
R0 = squeeze(RKEM(i,:,:));

% if i == 1
     L = 0.02*ones(d);
%     % L = zeros(d);
% else
%     L = squeeze(LEst(:,:,i-1));
% end

% Check stability
% [~,D] = eig(L);
% if any(abs(diag(D)) >= 1)
%     disp('Initial transition matrix is not stationary!');
%     break;
% end

F0 = [eye(d)+L,-L;eye(d),zeros(d)];

%% Rescale

if scaling
    
    c = mean(mean(Q0))*10;
    
    Q0 = Q0/c;
    R0 = R0/c;
    
    P = P/sqrt(c);
    
end
